Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkSuperquadricSource Class Reference

`#include <vtkSuperquadricSource.h>`

Inheritance diagram for vtkSuperquadricSource:

[legend]
Collaboration diagram for vtkSuperquadricSource:

[legend]
List of all members.

## Detailed Description

create a polygonal superquadric centered

Date:
  2002/01/22 15:29:50

Revision:
  1.18

at the origin

vtkSuperquadricSource creates a superquadric (represented by polygons) of specified size centered at the origin. The resolution (polygonal discretization) in both the latitude (phi) and longitude (theta) directions can be specified. Roundness parameters (PhiRoundness and ThetaRoundness) control the shape of the superquadric. The Toroidal boolean controls whether a toroidal superquadric is produced. If so, the Thickness parameter controls the thickness of the toroid: 0 is the thinnest allowable toroid, and 1 has a minimum sized hole. The Scale parameters allow the superquadric to be scaled in x, y, and z (normal vectors are correctly generated in any case). The Size parameter controls size of the superquadric.

This code is based on "Rigid physically based superquadrics", A. H. Barr, in "Graphics Gems III", David Kirk, ed., Academic Press, 1992.

Warning:
  Resolution means the number of latitude or longitude lines for a complete superquadric. The resolution parameters are rounded to the nearest 4 in phi and 8 in theta.

Warning:
  Texture coordinates are not equally distributed around all superquadrics.

Warning:
  The Size and Thickness parameters control coefficients of superquadric generation, and may do not exactly describe the size of the superquadric.

Created by:
  - Lorensen, Bill

CVS contributions (if > 5%):
  - Lorensen, Bill (90%)

CVS logs (CVSweb):
  - .`cxx` (`/Graphics/vtkSuperquadricSource.cxx)`
  - .`h` (`/Graphics/vtkSuperquadricSource.h)`

Examples:
  vtkSuperquadricSource (Examples)

Tests:
  vtkSuperquadricSource (Tests)

Definition at line 78 of file vtkSuperquadricSource.h.

## Public Types
typedef vtkPolyDataSource | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetCenter (float, float, float)
virtual void | SetCenter (float[3])
virtual float * | GetCenter ()
virtual void | GetCenter (float data[3])
virtual void | SetScale (float, float, float)
virtual void | SetScale (float[3])
virtual float * | GetScale ()
virtual void | GetScale (float data[3])
virtual int | GetThetaResolution ()
void | SetThetaResolution (int i)
virtual int | GetPhiResolution ()
void | SetPhiResolution (int i)
virtual float | GetThickness ()
virtual void | SetThickness (float)
virtual float | GetPhiRoundness ()
void | SetPhiRoundness (float e)
virtual float | GetThetaRoundness ()
void | SetThetaRoundness (float e)
virtual void | SetSize (float)
virtual float | GetSize ()
virtual void | ToroidalOn ()
virtual void | ToroidalOff ()
virtual int | GetToroidal ()
virtual void | SetToroidal (int)
## Static Public Methods
vtkSuperquadricSource * | New ()
int | IsTypeOf (const char *type)
vtkSuperquadricSource * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkSuperquadricSource (int res=16)
| ~vtkSuperquadricSource ()
void | Execute ()
## Protected Attributes
int | Toroidal
float | Thickness
float | Size
float | PhiRoundness
float | ThetaRoundness
float | Center [3]
float | Scale [3]
int | ThetaResolution
int | PhiResolution

## Member Typedef Documentation

typedef vtkPolyDataSource vtkSuperquadricSource::Superclass

| Reimplemented from vtkPolyDataSource. Definition at line 85 of file vtkSuperquadricSource.h.

## Constructor & Destructor Documentation

vtkSuperquadricSource::vtkSuperquadricSource | ( | int | res = 16 | ) | `[protected]`

vtkSuperquadricSource::~vtkSuperquadricSource | ( |  | ) | `[inline, protected]`

| Definition at line 149 of file vtkSuperquadricSource.h.

## Member Function Documentation

vtkSuperquadricSource* vtkSuperquadricSource::New | ( |  | ) | `[static]`

| Create a default superquadric with a radius of 0.5, non-toroidal, spherical, and centered at the origin. Reimplemented from vtkObject.

virtual const char* vtkSuperquadricSource::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataSource.

int vtkSuperquadricSource::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

virtual int vtkSuperquadricSource::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

vtkSuperquadricSource* vtkSuperquadricSource::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataSource.

void vtkSuperquadricSource::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataSource.

virtual void vtkSuperquadricSource::SetCenter | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual void vtkSuperquadricSource::SetCenter | ( | float | [3] | ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual float* vtkSuperquadricSource::GetCenter | ( |  | ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual void vtkSuperquadricSource::GetCenter | ( | float | data[3] | ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual void vtkSuperquadricSource::SetScale | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual void vtkSuperquadricSource::SetScale | ( | float | [3] | ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual float* vtkSuperquadricSource::GetScale | ( |  | ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual void vtkSuperquadricSource::GetScale | ( | float | data[3] | ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual int vtkSuperquadricSource::GetThetaResolution | ( |  | ) | `[virtual]`

| Set the number of points in the longitude direction.

void vtkSuperquadricSource::SetThetaResolution | ( | int | i | ) |

| Set the number of points in the longitude direction.

virtual int vtkSuperquadricSource::GetPhiResolution | ( |  | ) | `[virtual]`

| Set the number of points in the latitude direction.

void vtkSuperquadricSource::SetPhiResolution | ( | int | i | ) |

| Set the number of points in the latitude direction.

virtual float vtkSuperquadricSource::GetThickness | ( |  | ) | `[virtual]`

| Set/Get Superquadric ring thickness (toroids only). Changing thickness maintains the outside diameter of the toroid.

virtual void vtkSuperquadricSource::SetThickness | ( | float |  | ) | `[virtual]`

| Set/Get Superquadric ring thickness (toroids only). Changing thickness maintains the outside diameter of the toroid.

virtual float vtkSuperquadricSource::GetPhiRoundness | ( |  | ) | `[virtual]`

| Set/Get Superquadric north/south roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

void vtkSuperquadricSource::SetPhiRoundness | ( | float | e | ) |

| Set/Get Superquadric north/south roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

virtual float vtkSuperquadricSource::GetThetaRoundness | ( |  | ) | `[virtual]`

| Set/Get Superquadric east/west roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

void vtkSuperquadricSource::SetThetaRoundness | ( | float | e | ) |

| Set/Get Superquadric east/west roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

virtual void vtkSuperquadricSource::SetSize | ( | float |  | ) | `[virtual]`

| Set/Get Superquadric isotropic size.

virtual float vtkSuperquadricSource::GetSize | ( |  | ) | `[virtual]`

| Set/Get Superquadric isotropic size.

virtual void vtkSuperquadricSource::ToroidalOn | ( |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

virtual void vtkSuperquadricSource::ToroidalOff | ( |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

virtual int vtkSuperquadricSource::GetToroidal | ( |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

virtual void vtkSuperquadricSource::SetToroidal | ( | int |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

void vtkSuperquadricSource::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

## Member Data Documentation

int vtkSuperquadricSource::Toroidal`[protected]`

| Definition at line 151 of file vtkSuperquadricSource.h.

float vtkSuperquadricSource::Thickness`[protected]`

| Definition at line 152 of file vtkSuperquadricSource.h.

float vtkSuperquadricSource::Size`[protected]`

| Definition at line 153 of file vtkSuperquadricSource.h.

float vtkSuperquadricSource::PhiRoundness`[protected]`

| Definition at line 154 of file vtkSuperquadricSource.h.

float vtkSuperquadricSource::ThetaRoundness`[protected]`

| Definition at line 155 of file vtkSuperquadricSource.h.

float vtkSuperquadricSource::Center[3]`[protected]`

| Definition at line 157 of file vtkSuperquadricSource.h.

float vtkSuperquadricSource::Scale[3]`[protected]`

| Definition at line 158 of file vtkSuperquadricSource.h.

int vtkSuperquadricSource::ThetaResolution`[protected]`

| Definition at line 159 of file vtkSuperquadricSource.h.

int vtkSuperquadricSource::PhiResolution`[protected]`

| Definition at line 160 of file vtkSuperquadricSource.h.

The documentation for this class was generated from the following file:

- Graphics/vtkSuperquadricSource.h